<?php
/**
 * @copyright © 2007, 2008, 2009 Intrahealth International, Inc.
 * This File is part of I2CE
 *
 * I2CE is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
    * @package I2CE
    * @author Carl Leitner <litlfred@ibiblio.org>
    * @since v2.0.0
    * @version v2.0.0
    */
/**
 * Class for defining all the database fields used by a {@link I2CE_Form} object.
 * @package I2CE
 * @access public
 */
class I2CE_FormField_ASSOC_PERCENT extends I2CE_FormField_ASSOC_FLOAT { 




    public function setValueOfKey($key,$val) {
        if (is_string($val)) {
            $val = doubleval(str_replace(",","",$val));
            if (preg_match('/\s*(-?[0-9]*(\.[0-9]*))?\s*%\s*$/',$val)) {
                $val = (float) $matches[1];
            }
        }
        if ( ! is_numeric($val)) {
            return;
        }
        parent::setValueOfKey($key,$val);
    }
    
    protected function getSingleDisplayValue($val) {
        return $val . ' %';
    }


    /**
     * Return the value of this field from the database format for the given type
     * @param integer $type The type of the field to be returned.
     * @param mixed $value
     */
    public function getFromDB($value ) {
        $vals =  json_decode($value,true );
        if (!is_array($vals)) {
            return $vals;
        }
        foreach ($vals as &$val) {
            $val = doubleval(str_replace(",","",$val));
            if (!is_string($val) && preg_match('/^\s*(-?[0-9]*(\.[0-9]*))?\s*%\s*$/',$val)) {
                $val = (float) $matches[1];
            }
        }
        unset($val);
        return $vals;
    }
        




}

# Local Variables:
# mode: php
# c-default-style: "bsd"
# indent-tabs-mode: nil
# c-basic-offset: 4
# End:
